defmodule Foo do
  
@doc ~S"""
When data = `:invoice_issue`

creates lawfirms and clients and:

    * `opts[:lawfirm_issues]` lawfirm issues
    * `opts[:timekeeper_issues]` for each client

and batches invoice_issues per client:

    * the first `opts[:lawfirm_issues]` invoice issues are lawfirm issues
      * the first of these invoice issue belongs to the first lawfirm issue, the second to the second and so on
    * the next `opts[:timekeeper_issues]` invoice issues are timekeeper issues
      * each one of these invoice issues is linked to all timekeeper issues for the client in a full mesh
    * the rest are generic invoice issues

     li   = lawfirm issue
     cNiM = invoice issue M for client N
     cNtiM = timekeeper issue M for client N


  Example:

    `up(:lawfirm_issue, clients: 2, lawfirm_issues: 2, timekeeper_issues: 2, batches: 6)`

  Result:

    li1    l12
     |     |_____________________________________
     |_____|________________________________     |
     |     |                                |    |
    c1i1 c2i2 c1i3 c1i4 c1i5 c1i6         c1i1 c2i2 c1i3 c1i4 c1i5 c1i6
              |  \ /  |                             |  \ /  |
              |  / \  |                             |  / \  |
            c1ti1 c1ti2                           c2ti1 c2ti2

    In the diagram above, there are:

      2 clients
      2 lawfirm issues li1 and li2
      2 * 2 = 4 timekeeper_issues c1ti1, c1ti2, c2ti1, c2ti2
      2 * 6 = 12 invoice_issues

  the first 2 invoice issues of each client are linked to li1 and li2
  the second 2 invoice issues of each clients are linked to the 2 timekeeper issues of the client in a full mesh

When data = `:timekeeper_issue`

creates `opts[:timekeeper_issues`] per client"
"""
def up(data, opts \\ [])
end 